<?php

namespace DarksLight2\Battle\Techniques;

use DarksLight2\Entity;
use DarksLight2\Traits\Singleton;

class TechniquesEntity extends Entity
{
    use Singleton;

    public int $id;
    public string $name;
    public string $description;
    public string $image;
    public int $category_id;
    public int $delay;
    public float $spirit_points;
    public int $critical_points;
    public int $parry_points;
    public int $defense_points;
    public int $damage_points;
    public ?int $skip;
    public int $level;
}