<?php

namespace DarksLight2\Training\Steps;

use DarksLight2\Training\StepFactory;

class MyUserFirstStep extends StepFactory
{

    public function getTitle(): string
    {
        return 'Персонаж.';
    }

    public function getMessage(): string
    {
        return 'В нашей игре, ваш персонаж расположен слева от экрана с игровыми локациями, там же, можно увидеть пустые слоты под предметы и параметры персонажа, ваш опыт, деньги, ежедневные задания...';
    }

    public function getShortName(): string
    {
        return 'my_user_first_step';
    }

    public function getRewards(): array
    {
        return [];
    }

}