<?php

namespace DarksLight2\Training\Steps;

use DarksLight2\Training\StepFactory;

class MyUserFourthStep extends StepFactory
{

    public function getTitle(): string
    {
        return 'Персонаж.';
    }

    public function getMessage(): string
    {
        return '"Параметры Персонажа"<br>
                Все игроки имеют свободные очки распределения параметров, что они дают игрокам конкретные модификаторы в зависимости от того, в какой из параметров распределяются очки распределения.<br>
                --- если можно, добавить скрин как выглядит эта кнопка ---
                Сила - Увеличивает мощность рубящего урона ( для Силачей )<br>
                Ловкость - Увеличивает мощность колющего урона ( для Критоуворотов и Уворотов )<br>
                Интуиция - Увеличивает мощность режущего урона ( для Критовиков )<br>
                Выносливость - Увеличивает защиту от урона и магии, а так же добавит немного жизней. ( для Танков )<br>
                Интелект - Увеличивает мощность магии. ( Для Любого Мага )<br>
                Мудрость - Увеличивает колличество маны. ( Для Любого Мага  )<br>
                <br>
                Дополнительно, игроки имеют очки распределения Мастерства Оружия, это позволит воинам увеличить урон, а магам, открыть новые приемы.<br>
                Очки распределения Оружий распределяются точно так же, как и очки распределения параметров ( статов ).<br>
                <br>
                В случае, если вы распределили неверно любые доступные очки распределения, или хотите их изменить, вы можете это сделать, поднявшись на 2 этаж здания " Бойцовский Клуб ".';
    }

    public function getShortName(): string
    {
        return 'my_user_fourth_step';
    }

    public function getRewards(): array
    {
        return [];
    }

    public function getAnswer(): string
    {
        return '';
    }

}