<?php

namespace DarksLight2\Training\Steps;

use DarksLight2\Training\StepFactory;

class MyUserThirdStep extends StepFactory
{

    public function getTitle(): string
    {
        return 'Персонаж.';
    }

    public function getMessage(): string
    {
        return 'В нашей игре, существует 5 Воинских и 4 Магических класса, такие как:<br>
                Критовик - Убивает Танков и Магов, основное оружие - Мечи<br>
                Уворот - Убивает Критовиков и Силачей, основное оружие - Кинжалы<br>
                Танк - Убивает Уворотов и Силачей, основное оружие - Дубина и щит.<br>
                Силач - Убивает Критовиков и Магов, основное оружие - Топоры<br>
                Критоуворот - Убивает Силачей и с небольшим шансом Критовиков и Уворотов, основное оружие - Кинжалы.<br>
                <br>
                Маг Огня - Атакующий маг, убивает Уворотов и Танков.<br>
                Маг Воздуха - Атакующий маг, убивает Уворотов и Танков.<br>
                Маг Земли - Защищающийся маг, слабый урон, хорошая защита.<br>
                Маг Воды - Защищающийся маг, слабый урон, хорошая защита.';
    }

    public function getShortName(): string
    {
        return 'my_user_third_step';
    }

    public function getRewards(): array
    {
        return [];
    }

    public function allowedToMove(): array
    {
        return ['cp1'];
    }

}